library ieee; 
use IEEE.STD_LOGIC_1164.ALL;

architecture imp4BFA of 4BitFullAdder is
  
  -- include 1BitFullAdder Element
  component 1BitFullAdder
    port(
      -- deklariere die Ports des Elementes für anschl. Portmapping
      InputAxDI, InputBxDI, CarryInxDI : in STD_LOGIC;
      SumxDO, CarryOutxDO : out STD_LOGIC);
  end component;
  
   -- include 1BitHalfAdder Element
  component 1BitHalfAdder
    port(
      -- deklariere die Ports des Elementes für anschl. Portmapping
      InputAxDI, InputBxDI: in STD_LOGIC;
      SumxDO, CarryOutxDO : out STD_LOGIC);
    end component;

  -- erstelle signal-vector um die 1-Bit-Adder im Modul 4-bit-Adder zu vernetzen
  SIGNAL carry_sig: std_logic_vector(4 DOWNTO 0); -- Grösse: 5Bit (Wie Output)

  BEGIN

  -- füge 1x 1B-half-A hinzu und 3x 1B-full-A
    -- Modul-Name: HA0, Modul-Typ: 1BitHalfAdder, port-map mit: Ports of 4BitFullAdder
    -- Details Port Mapping:
    -- Map NumA(0) vom 4BitFullAdder mit InputAxDI vom 1BitHalfAdder etc...
    HA0: 1BitHalfAdder port map (NumA(0), NumB(0), Sum(0),       carry_sig(0)); --none
    FA1: 1BitFullAdder port map (NumA(1), NumB(1), carry_sig(0), Sum(1),        carry_sig(1));
    FA2: 1BitFullAdder port map (NumA(2), NumB(2), carry_sig(1), Sum(2),        carry_sig(2));
    FA3: 1BitFullAdder port map (NumA(3), NumB(3), carry_sig(2), Sum(3),        Sum(4));

end imp4BFA;
